Index: issm/trunk-jpl/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.cpp	(revision 15564)
@@ -9396,5 +9396,5 @@
 
 	/*Get dof list: */
-	GetDofList(&doflist,PattynApproximationEnum,GsetEnum);
+	GetDofList(&doflist,HOApproximationEnum,GsetEnum);
 
 	/*Get node data: */
@@ -9452,6 +9452,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticPattynStokes {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticPattynStokes(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticHOFS {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticHOFS(IssmDouble* solution){
 
 	const int    numdofp=NDOF2*NUMVERTICES;
@@ -9459,27 +9459,27 @@
 
 	int    i;
-	IssmDouble pattyn_values[numdofp];
-	IssmDouble stokes_values[numdofs];
+	IssmDouble HO_values[numdofp];
+	IssmDouble FS_values[numdofs];
 	IssmDouble vx[NUMVERTICES];
 	IssmDouble vy[NUMVERTICES];
 	IssmDouble vz[NUMVERTICES];
-	IssmDouble vzpattyn[NUMVERTICES];
-	IssmDouble vzstokes[NUMVERTICES];
+	IssmDouble vzHO[NUMVERTICES];
+	IssmDouble vzFS[NUMVERTICES];
 	IssmDouble vel[NUMVERTICES];
 	IssmDouble pressure[NUMVERTICES];
 	IssmDouble xyz_list[NUMVERTICES][3];
-	IssmDouble stokesreconditioning;
+	IssmDouble FSreconditioning;
 	int*   doflistp      = NULL;
 	int*   doflists      = NULL;
 	Penta  *penta        = NULL;
 
-	/*OK, we have to add results of this element for pattyn 
-	 * and results from the penta at base for macayeal. Now recover results*/
+	/*OK, we have to add results of this element for HO 
+	 * and results from the penta at base for SSA. Now recover results*/
 	penta=GetBasalElement();
 
-	/*Get dof listof this element (pattyn dofs) and of the penta at base (macayeal dofs): */
-	GetDofList(&doflistp,PattynApproximationEnum,GsetEnum);
-	GetDofList(&doflists,StokesApproximationEnum,GsetEnum);
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
+	/*Get dof listof this element (HO dofs) and of the penta at base (SSA dofs): */
+	GetDofList(&doflistp,HOApproximationEnum,GsetEnum);
+	GetDofList(&doflists,FSApproximationEnum,GsetEnum);
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
 
 	/*Get node data: */
@@ -9487,40 +9487,40 @@
 
 	/*Use the dof list to index into the solution vector: */
-	for(i=0;i<numdofp;i++) pattyn_values[i]=solution[doflistp[i]];
-	for(i=0;i<numdofs;i++) stokes_values[i]=solution[doflists[i]];
+	for(i=0;i<numdofp;i++) HO_values[i]=solution[doflistp[i]];
+	for(i=0;i<numdofs;i++) FS_values[i]=solution[doflists[i]];
 
 	/*Transform solution in Cartesian Space*/
-	TransformSolutionCoord(&pattyn_values[0],this->nodes,NUMVERTICES,XYEnum);
-	TransformSolutionCoord(&stokes_values[0],this->nodes,NUMVERTICES,XYZPEnum);
+	TransformSolutionCoord(&HO_values[0],this->nodes,NUMVERTICES,XYEnum);
+	TransformSolutionCoord(&FS_values[0],this->nodes,NUMVERTICES,XYZPEnum);
 
 	/*Ok, we have vx and vy in values, fill in vx and vy arrays: */
 	for(i=0;i<NUMVERTICES;i++){
-		vx[i]=stokes_values[i*NDOF4+0]+pattyn_values[i*NDOF2+0];
-		vy[i]=stokes_values[i*NDOF4+1]+pattyn_values[i*NDOF2+1];
-		vzstokes[i]=stokes_values[i*NDOF4+2];
-		pressure[i]=stokes_values[i*NDOF4+3]*stokesreconditioning;
+		vx[i]=FS_values[i*NDOF4+0]+HO_values[i*NDOF2+0];
+		vy[i]=FS_values[i*NDOF4+1]+HO_values[i*NDOF2+1];
+		vzFS[i]=FS_values[i*NDOF4+2];
+		pressure[i]=FS_values[i*NDOF4+3]*FSreconditioning;
 
 		/*Check solution*/
 		if(xIsNan<IssmDouble>(vx[i]))       _error_("NaN found in solution vector");
 		if(xIsNan<IssmDouble>(vy[i]))       _error_("NaN found in solution vector");
-		if(xIsNan<IssmDouble>(vzstokes[i])) _error_("NaN found in solution vector");
+		if(xIsNan<IssmDouble>(vzFS[i])) _error_("NaN found in solution vector");
 		if(xIsNan<IssmDouble>(pressure[i])) _error_("NaN found in solution vector");
 	}
 
 	/*Get Vz*/
-	Input* vzpattyn_input=inputs->GetInput(VzPattynEnum);
-	if (vzpattyn_input){
-		if (vzpattyn_input->ObjectEnum()!=PentaInputEnum){
-			_error_("Cannot compute Vel as VzPattyn is of type " << EnumToStringx(vzpattyn_input->ObjectEnum()));
-		}
-		GetInputListOnVertices(&vzpattyn[0],VzPattynEnum);
+	Input* vzHO_input=inputs->GetInput(VzHOEnum);
+	if (vzHO_input){
+		if (vzHO_input->ObjectEnum()!=PentaInputEnum){
+			_error_("Cannot compute Vel as VzHO is of type " << EnumToStringx(vzHO_input->ObjectEnum()));
+		}
+		GetInputListOnVertices(&vzHO[0],VzHOEnum);
 	}
 	else{
-		_error_("Cannot update solution as VzPattyn is not present");
+		_error_("Cannot update solution as VzHO is not present");
 	}
 
 	/*Now Compute vel*/
 	for(i=0;i<NUMVERTICES;i++) {
-		vz[i]=vzpattyn[i]+vzstokes[i];
+		vz[i]=vzHO[i]+vzFS[i];
 		vel[i]=pow( pow(vx[i],2.0) + pow(vy[i],2.0) + pow(vz[i],2.0) , 0.5);
 	}
@@ -9537,5 +9537,5 @@
 	this->inputs->AddInput(new PentaInput(VyEnum,vy,P1Enum));
 	this->inputs->AddInput(new PentaInput(VzEnum,vz,P1Enum));
-	this->inputs->AddInput(new PentaInput(VzStokesEnum,vzstokes,P1Enum));
+	this->inputs->AddInput(new PentaInput(VzFSEnum,vzFS,P1Enum));
 	this->inputs->AddInput(new PentaInput(VelEnum,vel,P1Enum));
 	this->inputs->AddInput(new PentaInput(PressureEnum,pressure,P1Enum));
@@ -9546,6 +9546,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticHutter {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticHutter(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticSIA {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticSIA(IssmDouble* solution){
 
 	const int    numdof=NDOF2*NUMVERTICES;
@@ -9621,7 +9621,7 @@
 	IssmDouble   vy[NUMVERTICES];
 	IssmDouble   vz[NUMVERTICES];
-	IssmDouble   vzmacayeal[NUMVERTICES];
-	IssmDouble   vzpattyn[NUMVERTICES];
-	IssmDouble   vzstokes[NUMVERTICES];
+	IssmDouble   vzSSA[NUMVERTICES];
+	IssmDouble   vzHO[NUMVERTICES];
+	IssmDouble   vzFS[NUMVERTICES];
 	IssmDouble   vel[NUMVERTICES];
 	IssmDouble   pressure[NUMVERTICES];
@@ -9630,7 +9630,7 @@
 	int*     doflist      = NULL;
 
-	/*Get the approximation and do nothing if the element in Stokes or None*/
+	/*Get the approximation and do nothing if the element in FS or None*/
 	inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(approximation==StokesApproximationEnum || approximation==NoneApproximationEnum){
+	if(approximation==FSApproximationEnum || approximation==NoneApproximationEnum){
 		return;
 	}
@@ -9653,27 +9653,27 @@
 	GetInputListOnVertices(&vy[0],VyEnum,0.0); //default is 0
 
-	/*Do some modifications if we actually have a PattynStokes or MacAyealStokes element*/
-	if(approximation==PattynStokesApproximationEnum){
-		Input* vzstokes_input=inputs->GetInput(VzStokesEnum);
-		if (vzstokes_input){
-			if (vzstokes_input->ObjectEnum()!=PentaInputEnum) _error_("Cannot compute Vel as VzStokes is of type " << EnumToStringx(vzstokes_input->ObjectEnum()));
-			GetInputListOnVertices(&vzstokes[0],VzStokesEnum);
-		}
-		else _error_("Cannot compute Vz as VzStokes in not present in PattynStokes element");
+	/*Do some modifications if we actually have a HOFS or MacAyealFS element*/
+	if(approximation==HOFSApproximationEnum){
+		Input* vzFS_input=inputs->GetInput(VzFSEnum);
+		if (vzFS_input){
+			if (vzFS_input->ObjectEnum()!=PentaInputEnum) _error_("Cannot compute Vel as VzFS is of type " << EnumToStringx(vzFS_input->ObjectEnum()));
+			GetInputListOnVertices(&vzFS[0],VzFSEnum);
+		}
+		else _error_("Cannot compute Vz as VzFS in not present in HOFS element");
 		for(i=0;i<NUMVERTICES;i++){
-			vzpattyn[i]=vz[i];
-			vz[i]=vzpattyn[i]+vzstokes[i];
-		}
-	}
-	else if(approximation==MacAyealStokesApproximationEnum){
-		Input* vzstokes_input=inputs->GetInput(VzStokesEnum);
-		if (vzstokes_input){
-			if (vzstokes_input->ObjectEnum()!=PentaInputEnum) _error_("Cannot compute Vel as VzStokes is of type " << EnumToStringx(vzstokes_input->ObjectEnum()));
-			GetInputListOnVertices(&vzstokes[0],VzStokesEnum);
-		}
-		else _error_("Cannot compute Vz as VzStokes in not present in MacAyealStokes element");
+			vzHO[i]=vz[i];
+			vz[i]=vzHO[i]+vzFS[i];
+		}
+	}
+	else if(approximation==MacAyealFSApproximationEnum){
+		Input* vzFS_input=inputs->GetInput(VzFSEnum);
+		if (vzFS_input){
+			if (vzFS_input->ObjectEnum()!=PentaInputEnum) _error_("Cannot compute Vel as VzFS is of type " << EnumToStringx(vzFS_input->ObjectEnum()));
+			GetInputListOnVertices(&vzFS[0],VzFSEnum);
+		}
+		else _error_("Cannot compute Vz as VzFS in not present in MacAyealFS element");
 		for(i=0;i<NUMVERTICES;i++){
-			vzmacayeal[i]=vz[i];
-			vz[i]=vzmacayeal[i]+vzstokes[i];
+			vzSSA[i]=vz[i];
+			vz[i]=vzSSA[i]+vzFS[i];
 		}
 	}
@@ -9683,6 +9683,6 @@
 
 	/*For pressure: we have not computed pressure in this analysis, for this element. We are in 3D, 
-	 *so the pressure is just the pressure at the z elevation: except it this is a PattynStokes element */
-	if(approximation!=PattynStokesApproximationEnum &&  approximation!=MacAyealStokesApproximationEnum){
+	 *so the pressure is just the pressure at the z elevation: except it this is a HOFS element */
+	if(approximation!=HOFSApproximationEnum &&  approximation!=MacAyealFSApproximationEnum){
 		rho_ice=matpar->GetRhoIce();
 		g=matpar->GetG();
@@ -9695,13 +9695,13 @@
 	this->inputs->ChangeEnum(VzEnum,VzPicardEnum);
 
-	if(approximation!=PattynStokesApproximationEnum && approximation!=MacAyealStokesApproximationEnum){
+	if(approximation!=HOFSApproximationEnum && approximation!=MacAyealFSApproximationEnum){
 		this->inputs->ChangeEnum(PressureEnum,PressurePicardEnum);
 		this->inputs->AddInput(new PentaInput(PressureEnum,pressure,P1Enum));
 	}
-	else if(approximation==PattynStokesApproximationEnum){
-		this->inputs->AddInput(new PentaInput(VzPattynEnum,vzpattyn,P1Enum));
-	}
-	else if(approximation==MacAyealStokesApproximationEnum){
-		this->inputs->AddInput(new PentaInput(VzMacAyealEnum,vzmacayeal,P1Enum));
+	else if(approximation==HOFSApproximationEnum){
+		this->inputs->AddInput(new PentaInput(VzHOEnum,vzHO,P1Enum));
+	}
+	else if(approximation==MacAyealFSApproximationEnum){
+		this->inputs->AddInput(new PentaInput(VzMacAyealEnum,vzSSA,P1Enum));
 	}
 	this->inputs->AddInput(new PentaInput(VzEnum,vz,P1Enum));
@@ -9712,6 +9712,6 @@
 }
 /*}}}*/
-/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticStokes {{{*/
-void  Penta::InputUpdateFromSolutionDiagnosticStokes(IssmDouble* solution){
+/*FUNCTION Penta::InputUpdateFromSolutionDiagnosticFS {{{*/
+void  Penta::InputUpdateFromSolutionDiagnosticFS(IssmDouble* solution){
 
 	const int numdof=NDOF4*NUMVERTICES;
@@ -9724,9 +9724,9 @@
 	IssmDouble  vel[NUMVERTICES];
 	IssmDouble  pressure[NUMVERTICES];
-	IssmDouble  stokesreconditioning;
+	IssmDouble  FSreconditioning;
 	int*    doflist=NULL;
 
 	/*Get dof list: */
-	GetDofList(&doflist,StokesApproximationEnum,GsetEnum);
+	GetDofList(&doflist,FSApproximationEnum,GsetEnum);
 
 	/*Use the dof list to index into the solution vector: */
@@ -9751,6 +9751,6 @@
 
 	/*Recondition pressure and compute vel: */
-	this->parameters->FindParam(&stokesreconditioning,DiagnosticStokesreconditioningEnum);
-	for(i=0;i<NUMVERTICES;i++) pressure[i]=pressure[i]*stokesreconditioning;
+	this->parameters->FindParam(&FSreconditioning,DiagnosticFSreconditioningEnum);
+	for(i=0;i<NUMVERTICES;i++) pressure[i]=pressure[i]*FSreconditioning;
 	for(i=0;i<NUMVERTICES;i++) vel[i]=pow( pow(vx[i],2.0) + pow(vy[i],2.0) + pow(vz[i],2.0) , 0.5);
 
Index: issm/trunk-jpl/src/c/classes/Elements/Penta.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Penta.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/Penta.h	(revision 15564)
@@ -145,9 +145,9 @@
 		void   Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index);
 		void   GradjDragMacAyeal(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjDragPattyn(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjDragStokes(Vector<IssmDouble>* gradient,int control_index);
+		void   GradjDragHO(Vector<IssmDouble>* gradient,int control_index);
+		void   GradjDragFS(Vector<IssmDouble>* gradient,int control_index);
 		void   GradjBbarMacAyeal(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjBbarPattyn(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjBbarStokes(Vector<IssmDouble>* gradient,int control_index);
+		void   GradjBbarHO(Vector<IssmDouble>* gradient,int control_index);
+		void   GradjBbarFS(Vector<IssmDouble>* gradient,int control_index);
 		void   GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data);
 		void   SetControlInputsFromVector(IssmDouble* vector,int control_enum,int control_index);
@@ -197,5 +197,5 @@
 		void	         GetSolutionFromInputsEnthalpy(Vector<IssmDouble>* solutiong);
 		IssmDouble     GetStabilizationParameter(IssmDouble u, IssmDouble v, IssmDouble w, IssmDouble diameter, IssmDouble kappa);
-		void    GetStrainRate3dPattyn(IssmDouble* epsilon,IssmDouble* xyz_list, GaussPenta* gauss, Input* vx_input, Input* vy_input);
+		void    GetStrainRate3dHO(IssmDouble* epsilon,IssmDouble* xyz_list, GaussPenta* gauss, Input* vx_input, Input* vy_input);
 		void    GetStrainRate3d(IssmDouble* epsilon,IssmDouble* xyz_list, GaussPenta* gauss, Input* vx_input, Input* vy_input, Input* vz_input);
 		Penta*  GetUpperElement(void);
@@ -215,6 +215,6 @@
 		bool    IsOnWater(void); 
 		IssmDouble  MinEdgeLength(IssmDouble xyz_list[6][3]);
-		void	  ReduceMatrixStokes(IssmDouble* Ke_reduced, IssmDouble* Ke_temp);
-		void	  ReduceVectorStokes(IssmDouble* Pe_reduced, IssmDouble* Ke_temp, IssmDouble* Pe_temp);
+		void	  ReduceMatrixFS(IssmDouble* Ke_reduced, IssmDouble* Ke_temp);
+		void	  ReduceVectorFS(IssmDouble* Pe_reduced, IssmDouble* Ke_temp, IssmDouble* Pe_temp);
 		void	  SetClone(int* minranks);
 		Tria*	  SpawnTria(int g0, int g1, int g2);
@@ -223,76 +223,76 @@
 
 		#ifdef _HAVE_DIAGNOSTIC_
-		ElementMatrix* CreateKMatrixCouplingMacAyealPattyn(void);
-		ElementMatrix* CreateKMatrixCouplingMacAyealPattynViscous(void);
-		ElementMatrix* CreateKMatrixCouplingMacAyealPattynFriction(void);
-		ElementMatrix* CreateKMatrixCouplingMacAyealStokes(void);
-		ElementMatrix* CreateKMatrixCouplingMacAyealStokesViscous(void);
-		ElementMatrix* CreateKMatrixCouplingMacAyealStokesFriction(void);
-		ElementMatrix* CreateKMatrixCouplingPattynStokes(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealHO(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealHOViscous(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealHOFriction(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealFS(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealFSViscous(void);
+		ElementMatrix* CreateKMatrixCouplingMacAyealFSFriction(void);
+		ElementMatrix* CreateKMatrixCouplingHOFS(void);
 		ElementMatrix* CreateKMatrixDiagnosticHoriz(void);
 		ElementMatrix* CreateKMatrixAdjointHoriz(void);
 		ElementVector* CreateDVectorDiagnosticHoriz(void);
-		ElementVector* CreateDVectorDiagnosticStokes(void);
-		ElementMatrix* CreateKMatrixDiagnosticHutter(void);
+		ElementVector* CreateDVectorDiagnosticFS(void);
+		ElementMatrix* CreateKMatrixDiagnosticSIA(void);
 		ElementMatrix* CreateKMatrixDiagnosticMacAyeal2d(void);
 		ElementMatrix* CreateKMatrixDiagnosticMacAyeal3d(void);
 		ElementMatrix* CreateKMatrixDiagnosticMacAyeal3dViscous(void);
 		ElementMatrix* CreateKMatrixDiagnosticMacAyeal3dFriction(void);
-		ElementMatrix* CreateKMatrixDiagnosticMacAyealPattyn(void);
-		ElementMatrix* CreateKMatrixDiagnosticMacAyealStokes(void);
+		ElementMatrix* CreateKMatrixDiagnosticMacAyealHO(void);
+		ElementMatrix* CreateKMatrixDiagnosticMacAyealFS(void);
 		ElementMatrix* CreateKMatrixDiagnosticL1L2(void);
 		ElementMatrix* CreateKMatrixDiagnosticL1L2Viscous(void);
 		ElementMatrix* CreateKMatrixDiagnosticL1L2Friction(void);
-		ElementMatrix* CreateKMatrixDiagnosticPattyn(void);
-		ElementMatrix* CreateKMatrixDiagnosticPattynViscous(void);
-		ElementMatrix* CreateKMatrixDiagnosticPattynFriction(void);
-		ElementMatrix* CreateKMatrixDiagnosticPattynStokes(void);
-		ElementMatrix* CreateKMatrixDiagnosticStokes(void);
-		ElementMatrix* CreateKMatrixDiagnosticStokesViscous(void);
-		ElementMatrix* CreateKMatrixDiagnosticStokesGLSViscous(void);
-		ElementMatrix* CreateKMatrixDiagnosticStokesFriction(void);
-		ElementMatrix* CreateKMatrixDiagnosticStokesGLSFriction(void);
+		ElementMatrix* CreateKMatrixDiagnosticHO(void);
+		ElementMatrix* CreateKMatrixDiagnosticHOViscous(void);
+		ElementMatrix* CreateKMatrixDiagnosticHOFriction(void);
+		ElementMatrix* CreateKMatrixDiagnosticHOFS(void);
+		ElementMatrix* CreateKMatrixDiagnosticFS(void);
+		ElementMatrix* CreateKMatrixDiagnosticFSViscous(void);
+		ElementMatrix* CreateKMatrixDiagnosticFSGLSViscous(void);
+		ElementMatrix* CreateKMatrixDiagnosticFSFriction(void);
+		ElementMatrix* CreateKMatrixDiagnosticFSGLSFriction(void);
 		ElementMatrix* CreateKMatrixDiagnosticVert(void);
 		ElementMatrix* CreateKMatrixDiagnosticVertVolume(void);
 		ElementMatrix* CreateKMatrixDiagnosticVertSurface(void);
 		ElementMatrix* CreateJacobianDiagnosticHoriz(void);
-		ElementMatrix* CreateJacobianDiagnosticMacayeal2d(void);
-		ElementMatrix* CreateJacobianDiagnosticPattyn(void);
-		ElementMatrix* CreateJacobianDiagnosticStokes(void);
+		ElementMatrix* CreateJacobianDiagnosticSSA2d(void);
+		ElementMatrix* CreateJacobianDiagnosticHO(void);
+		ElementMatrix* CreateJacobianDiagnosticFS(void);
 		void           InputUpdateFromSolutionDiagnosticHoriz( IssmDouble* solutiong);
 		void           InputUpdateFromSolutionDiagnosticMacAyeal( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticMacAyealPattyn( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticMacAyealStokes( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticMacAyealHO( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticMacAyealFS( IssmDouble* solutiong);
 		void           InputUpdateFromSolutionDiagnosticL1L2( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticPattyn( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticPattynStokes( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticHutter( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticHO( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticHOFS( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticSIA( IssmDouble* solutiong);
 		void           InputUpdateFromSolutionDiagnosticVert( IssmDouble* solutiong);
-		void           InputUpdateFromSolutionDiagnosticStokes( IssmDouble* solutiong);
+		void           InputUpdateFromSolutionDiagnosticFS( IssmDouble* solutiong);
 		void	         GetSolutionFromInputsDiagnosticHoriz(Vector<IssmDouble>* solutiong);
-		void	         GetSolutionFromInputsDiagnosticHutter(Vector<IssmDouble>* solutiong);
-		void	         GetSolutionFromInputsDiagnosticStokes(Vector<IssmDouble>* solutiong);
+		void	         GetSolutionFromInputsDiagnosticSIA(Vector<IssmDouble>* solutiong);
+		void	         GetSolutionFromInputsDiagnosticFS(Vector<IssmDouble>* solutiong);
 		void	         GetSolutionFromInputsDiagnosticVert(Vector<IssmDouble>* solutiong);
-		ElementVector* CreatePVectorCouplingMacAyealStokes(void);
-		ElementVector* CreatePVectorCouplingMacAyealStokesViscous(void);
-		ElementVector* CreatePVectorCouplingMacAyealStokesFriction(void);
-		ElementVector* CreatePVectorCouplingPattynStokes(void);
-		ElementVector* CreatePVectorCouplingPattynStokesViscous(void);
-		ElementVector* CreatePVectorCouplingPattynStokesFriction(void);
+		ElementVector* CreatePVectorCouplingMacAyealFS(void);
+		ElementVector* CreatePVectorCouplingMacAyealFSViscous(void);
+		ElementVector* CreatePVectorCouplingMacAyealFSFriction(void);
+		ElementVector* CreatePVectorCouplingHOFS(void);
+		ElementVector* CreatePVectorCouplingHOFSViscous(void);
+		ElementVector* CreatePVectorCouplingHOFSFriction(void);
 		ElementVector* CreatePVectorDiagnosticHoriz(void);
-		ElementVector* CreatePVectorDiagnosticHutter(void);
+		ElementVector* CreatePVectorDiagnosticSIA(void);
 		ElementVector* CreatePVectorDiagnosticMacAyeal(void);
-		ElementVector* CreatePVectorDiagnosticMacAyealPattyn(void);
-		ElementVector* CreatePVectorDiagnosticMacAyealStokes(void);
+		ElementVector* CreatePVectorDiagnosticMacAyealHO(void);
+		ElementVector* CreatePVectorDiagnosticMacAyealFS(void);
 		ElementVector* CreatePVectorDiagnosticL1L2(void);
-		ElementVector* CreatePVectorDiagnosticPattyn(void);
-		ElementVector* CreatePVectorDiagnosticPattynDrivingStress(void);
-		ElementVector* CreatePVectorDiagnosticPattynFront(void);
-		ElementVector* CreatePVectorDiagnosticPattynStokes(void);
-		ElementVector* CreatePVectorDiagnosticStokes(void);
-		ElementVector* CreatePVectorDiagnosticStokesFront(void);
-		ElementVector* CreatePVectorDiagnosticStokesViscous(void);
-		ElementVector* CreatePVectorDiagnosticStokesGLSViscous(void);
-		ElementVector* CreatePVectorDiagnosticStokesShelf(void);
+		ElementVector* CreatePVectorDiagnosticHO(void);
+		ElementVector* CreatePVectorDiagnosticHODrivingStress(void);
+		ElementVector* CreatePVectorDiagnosticHOFront(void);
+		ElementVector* CreatePVectorDiagnosticHOFS(void);
+		ElementVector* CreatePVectorDiagnosticFS(void);
+		ElementVector* CreatePVectorDiagnosticFSFront(void);
+		ElementVector* CreatePVectorDiagnosticFSViscous(void);
+		ElementVector* CreatePVectorDiagnosticFSGLSViscous(void);
+		ElementVector* CreatePVectorDiagnosticFSShelf(void);
 		ElementVector* CreatePVectorDiagnosticVert(void);
 		ElementVector* CreatePVectorDiagnosticVertVolume(void);
@@ -304,11 +304,11 @@
 		ElementVector* CreatePVectorAdjointHoriz(void);
 		ElementMatrix* CreateKMatrixAdjointMacAyeal2d(void);
-		ElementMatrix* CreateKMatrixAdjointPattyn(void);
-		ElementMatrix* CreateKMatrixAdjointStokes(void);
+		ElementMatrix* CreateKMatrixAdjointHO(void);
+		ElementMatrix* CreateKMatrixAdjointFS(void);
 		ElementVector* CreatePVectorAdjointMacAyeal(void);
-		ElementVector* CreatePVectorAdjointPattyn(void);
-		ElementVector* CreatePVectorAdjointStokes(void);
+		ElementVector* CreatePVectorAdjointHO(void);
+		ElementVector* CreatePVectorAdjointFS(void);
 		void    InputUpdateFromSolutionAdjointHoriz( IssmDouble* solutiong);
-		void    InputUpdateFromSolutionAdjointStokes( IssmDouble* solutiong);
+		void    InputUpdateFromSolutionAdjointFS( IssmDouble* solutiong);
 		#endif
 
